Package org.zkoss.zkex.zul

## Class Fisheyebar

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zkex.zul.Fisheyebar

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Scope`, `ComponentCtrl`

      public class Fisheyebar
      extends XulElement

  A fisheye bar is a bar of `Fisheye` that is a menu similar to the fish eye menu on the Mac OS.

  Available in ZK PE and ZK EE.

  Default `getZclass()`: z-fisheyebar.

  Since:
    3.5.0
  Author:
    jumperchen
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `HtmlBasedComponent.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Fisheyebar()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `beforeChildAdded​(Component child, Component refChild)` | Default: does nothing.
    `java.lang.String` | `getAttachEdge()` | Returns the attach edge.
    `int` | `getItemHeight()` | Returns the item height of `Fisheye`.
    `int` | `getItemMaxHeight()` | Returns the item maximal height of `Fisheye`.
    `int` | `getItemMaxWidth()` | Returns the item maximal width of `Fisheye`.
    `int` | `getItemPadding()` | Returns the item padding of `Fisheye`.
    `int` | `getItemWidth()` | Returns the item width of `Fisheye`.
    `java.lang.String` | `getLabelEdge()` | Returns the label edge.
    `java.lang.String` | `getOrient()` | Returns the orientation of `Fisheye`.
    `java.lang.String` | `getZclass()` | Returns the ZK Cascading Style class for this component.
    `protected void` | `renderProperties​(ContentRenderer renderer)` | Renders the content of this component, excluding the enclosing tags and children.
    `void` | `setAttachEdge​(java.lang.String attachEdge)` | Sets the attach edge.
    `void` | `setItemHeight​(int itemhgh)` | Sets the item height of `Fisheye`.
    `void` | `setItemMaxHeight​(int itemmaxhgh)` | Sets the item maximal height of `Fisheye`.
    `void` | `setItemMaxWidth​(int itemmaxwd)` | Sets the item maximal width of `Fisheye`.
    `void` | `setItemPadding​(int itemPadding)` | Sets the item padding of `Fisheye`.
    `void` | `setItemWidth​(int itemwd)` | Sets the item width of `Fisheye`.
    `void` | `setLabelEdge​(java.lang.String labelEdge)` | Sets the label edge.
    `void` | `setOrient​(java.lang.String orient)` | Sets the orientation of `Fisheye`.

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `clone, getContext, getCtrlKeys, getPopup, getPropertyAccess, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, evalCSSFlex, focus, getAction, getClientAction, getDraggable, getDroppable, getExtraCtrl, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZindex, getZIndex, removeSclass, removeSclass, service, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight, setHeight0, setHeightDirectly, setHflex, setHflex0, setHflexDirectly, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex, setVflex0, setVflexDirectly, setWidth, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildRemoved, beforeParentChanged, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isChildable, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Fisheyebar

          public Fisheyebar()

  - ### Method Detail

    - #### getItemWidth

          public int getItemWidth()

      Returns the item width of `Fisheye`.

    - #### setItemWidth

          public void setItemWidth​(int itemwd)
                            throws WrongValueException

      Sets the item width of `Fisheye`.
      Throws:
        `WrongValueException`

    - #### getItemHeight

          public int getItemHeight()

      Returns the item height of `Fisheye`.

    - #### setItemHeight

          public void setItemHeight​(int itemhgh)
                             throws WrongValueException

      Sets the item height of `Fisheye`.
      Throws:
        `WrongValueException`

    - #### getItemMaxWidth

          public int getItemMaxWidth()

      Returns the item maximal width of `Fisheye`.

    - #### setItemMaxWidth

          public void setItemMaxWidth​(int itemmaxwd)
                               throws WrongValueException

      Sets the item maximal width of `Fisheye`.
      Throws:
        `WrongValueException`

    - #### getItemMaxHeight

          public int getItemMaxHeight()

      Returns the item maximal height of `Fisheye`.

    - #### setItemMaxHeight

          public void setItemMaxHeight​(int itemmaxhgh)
                                throws WrongValueException

      Sets the item maximal height of `Fisheye`.
      Throws:
        `WrongValueException`

    - #### getItemPadding

          public int getItemPadding()

      Returns the item padding of `Fisheye`.

    - #### setItemPadding

          public void setItemPadding​(int itemPadding)
                              throws WrongValueException

      Sets the item padding of `Fisheye`.
      Throws:
        `WrongValueException`

    - #### getOrient

          public java.lang.String getOrient()

      Returns the orientation of `Fisheye`.

    - #### setOrient

          public void setOrient​(java.lang.String orient)
                         throws WrongValueException

      Sets the orientation of `Fisheye`. Allowed values: horizontal, vertical
      Throws:
        `WrongValueException`

    - #### getAttachEdge

          public java.lang.String getAttachEdge()

      Returns the attach edge.

      Default: center

    - #### setAttachEdge

          public void setAttachEdge​(java.lang.String attachEdge)
                             throws WrongValueException

      Sets the attach edge. It will decide the direction to zoom the image if fisheye. Allowed values: center,top,bottom,left,right

      Note, "left","right" apply for getOrient() is "vertical"

      Throws:
        `WrongValueException`

    - #### getLabelEdge

          public java.lang.String getLabelEdge()

      Returns the label edge.

      Default: bottom

    - #### setLabelEdge

          public void setLabelEdge​(java.lang.String labelEdge)
                            throws WrongValueException

      Sets the label edge. Decides the direction to show the label of fisheye. Allowed values: center,top,bottom,left,right

      Note, "left","right" apply for getOrient() is "vertical"

      Throws:
        `WrongValueException`

    - #### getZclass

          public java.lang.String getZclass()

      Description copied from class: `HtmlBasedComponent`
      Returns the ZK Cascading Style class for this component. It usually depends on the implementation of the mold (`AbstractComponent.getMold()`).

      Default: null (the default value depends on element).

      `HtmlBasedComponent.setZclass(java.lang.String)`) will completely replace the default style of a component. In other words, the default style of a component is associated with the default value of `HtmlBasedComponent.getZclass()`. Once it is changed, the default style won't be applied at all. If you want to perform small adjustments, use `HtmlBasedComponent.setSclass(java.lang.String)` instead.

      Overrides:
        `getZclass` in class `HtmlBasedComponent`
      See Also:
        `HtmlBasedComponent.getSclass()`

    - #### beforeChildAdded

          public void beforeChildAdded​(Component child,
                                       Component refChild)

      Description copied from class: `AbstractComponent`
      Default: does nothing.
      Specified by:
        `beforeChildAdded` in interface `ComponentCtrl`
      Overrides:
        `beforeChildAdded` in class `AbstractComponent`
      Parameters:
        `child` - the child to be added (never null).
        `refChild` - another child component that the new child will be inserted before it. If null, the new child will be the last child.
      See Also:
        `ComponentCtrl.beforeChildAdded(org.zkoss.zk.ui.Component, org.zkoss.zk.ui.Component)`

    - #### renderProperties

          protected void renderProperties​(ContentRenderer renderer)
                                   throws java.io.IOException

      Description copied from class: `HtmlBasedComponent`
      Renders the content of this component, excluding the enclosing tags and children.

      See also ZK Client-side Reference: Property Rendering

      Overrides:
        `renderProperties` in class `XulElement`
      Throws:
        `java.io.IOException`